unit DefGerais;

interface

const cAutores = 'Autor A, Autor B, Autor C e Autor D';

const cAnoIni = '2016';
      cNomeBaseBD = 'MadeiraRecebida-';

const MaxOrigem = 1000;
      NomeMes : array [1..12] of string = ('Janeiro', 'Fevereiro', 'Maro', 
                             'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 
                             'Setembro', 'Outubro', 'Novembro', 'Dezembro');
      Especie : array [1..3] of string = 
              ('Eucalyptus saligna', 'Eucalyptus grandis', 'Pinus elliottii');

var NomeBD : string;
    AnoBD  : string;
    dtDia, dtMes, dtAno  : integer;
    DataAtual : string;

type TRegToraBD = record
                    Origem  : integer;
                    Mes     : integer;
                    Dia     : integer;
                    Especie : integer;
                    Peso    : real;
                    Compr   : real;
                    DiamInf : real;
                    DiamSup : real;
                    end;

function  FaixaMassaEspecifica(ME : real) : integer;
procedure Cabecalho(Arq : Text; NomeRelatorio : string);
procedure Rodape(Arq : Text);
procedure Mensagem(Texto : string; Col, Lin : integer; ComEspera : boolean);
procedure MostraTxt(NomeArq : string);

procedure ListaBD(NomeArq : string);
procedure DefineBD(Ano : string);
procedure TrocaBD;
procedure ImportaBD;

implementation      // ----------------------------------------------

{ Determinar Faixa padro em funo da massa especfica }
function FaixaMassaEspecifica(ME : real) : integer;
//var ...;
begin
  {...};
  if ME > 99 then FaixaMassaEspecifica := 0             { fora do padro }
  else if ME >= 95 then {...}                           { faixa ...      }
  {...}                                                 { faixa ...      }
  else {...};                                           { faixa ...      }
end;

//-------------------------------------------------------------------

{ Mostrar na tela o contedo de um arquivo de texto }
procedure MostraTxt(NomeArq : string);
var ArqTxt : Text;
    Linha  : string;
begin
  Assign(ArqTxt, NomeArq);
  Reset(ArqTxt);
  ClrScr;
  While not Eof(ArqTxt) do
    begin
    Readln(ArqTxt, Linha);
    Writeln(Linha);
    end;
  Close(ArqTxt);
end;

//-------------------------------------------------------------------

{ Rotinas de apoio ao projeto de relatrios } 
procedure Cabecalho(Arq : Text; NomeRelatorio : string);
var i: integer;
begin
  Writeln(Arq, 'UFPEL-CENG (MADEIRA PMICRO/ALGOPROG V3.0)');
  Writeln(Arq, 'ANO: ', AnoBD, '  ', NomeRelatorio);
  for i:=1 to 76 do
    Write(Arq, Chr(196));
  Writeln(Arq);
end;

procedure Rodape(Arq : Text);
var i: integer;
begin
  for i:=1 to 76 do
    Write(Arq, Chr(196));
  Writeln(Arq);
  Writeln(Arq, 'Programa desenvolvido pelos alunos ', cAutores);  
end;
  
{ Rotinas de apoio a manipulao de tela }
procedure Mensagem(Texto : string; Col, Lin : integer; ComEspera : boolean);
begin
  GotoXY(Col, Lin);
  Write(Texto);
  if ComEspera then Readkey;     // Qualquer tecla libera continuao
end;

//-------------------------------------------------------------------

{ Rotinas que implementam funcionalidades secundrias do projeto }
procedure ListaBD(NomeArq : string);
var ArqTorasTxt : text;
    ArqTorasBD  : file of TRegToraBD;
var Reg : TRegToraBD;
    n : integer;
    sNomeArqList : string;
begin
  GotoXY(1, 5);
  Assign(ArqTorasBD, NomeArq);
  Reset(ArqTorasBD); 
  if IOResult = 0 then
    begin
    { Ler os Registros do arquivo Binrio gravado (BD)  }
    { e produzir uma imagem em Texto (para conferncia) }
    sNomeArqList := NomeArq + '.TXT';
    Assign(ArqTorasTxt, sNomeArqList);
    Rewrite(ArqTorasTxt); 
    n := 0;
    while not Eof(ArqTorasBD) do
      begin
      Read(ArqTorasBD, Reg);     { a cada reg. lido, o "cursor" do arquivo }
                                 { passa para o prximo automaticamente    }
  
      with Reg do
        Writeln(ArqTorasTxt, Origem,#9, Mes,#9, Dia,#9, Especie,#9, Peso:0:3,#9,
                             Compr:0:3,#9, DiamInf:0:3,#9, DiamSup:0:3);
                        { #9  o mesmo que Chr(9), ou seja, o cdigo de um TAB;    }
                        { :0:3 significa formatar apenas o nmero de decimais,     }
                        { pois o "tamanho do campo"  ignorado se for insuficiente }
        inc(n);
        end;
    Close(ArqTorasTxt);
    Close(ArqTorasBD);
    Writeln(n, ' registros listados em arquivo texto temporrio');
    Writeln('Arquivo de listagem: ', sNomeArqList);
    end
  else
    begin
    Writeln('No foi possvel abrir o arquivo de banco de dados.');
    Writeln('# Erro nm. ', IOResult);
    Writeln('Verifique antes de tentar novamente!');
    end;
  Readkey;
end;

procedure DefineBD(Ano : string);
begin
  AnoBD  := Ano;
  NomeBD := cNomeBaseBD + AnoBD + '.dat';
end;

procedure TrocaBD;
var sAux, NovoNome : string;
begin
  Writeln;
  Writeln('** Troca do arquivo de banco de dados a ser usado **');
  Writeln;
  Write('Informe o Ano de referncia: ');
  Readln(AnoBD);
  Writeln;
  NovoNome := cNomeBaseBD + AnoBD + '.dat';
  TextColor(yellow);
  Writeln('Nome do arquivo (por falta): ', NovoNome);
  TextColor(white);
  Writeln('Confirme (Espao e Enter) ou informe o nome do arquivo de');
  Writeln('banco de dados a ser usado (com o caminho, se necessrio): ');
  Readln(sAux);
  while (length(sAux) > 0) and (sAux[1] <= ' ') do
    delete(sAux, 1, 1);
  if sAux <> '' then
    NovoNome := sAux;

  //Se NovoNome  vlido ...
  NomeBD := NovoNome;
end;

procedure ImportaBD;
var ArqTorasTxt : text;
    ArqTorasBD  : file of TRegToraBD;
var Reg : TRegToraBD;
    n : integer;
    NomeTxt, NomeBD : string;
begin
  Writeln('Informe o nome do arquivo texto a converter: ');
  Readln(NomeTxt);
  Writeln('Informe o nome do arquivo de Banco de Dados a gerar: ');
  Readln(NomeBD);

  Assign(ArqTorasBD, NomeBD);
  Rewrite(ArqTorasBD); 

  { Ler os Registros de Toras em Texto e gravar em Binrio (BD) }
  Assign(ArqTorasTxt, NomeTxt);
  Reset(ArqTorasTxt); 
  n := 0;
  while not Eof(ArqTorasTxt) do
    with Reg do                { para referenciar seus campos de forma simplificada, }
      begin                    { em vez de ..., Reg.Mes, Reg.Dia, ...                }
      Readln(ArqTorasTxt, Origem, Mes, Dia, Especie, Peso, Compr, DiamInf, DiamSup);
      Write(ArqTorasBD, Reg);
      inc(n)
      end;
  Close(ArqTorasTxt);
  Close(ArqTorasBD);

  Writeln(n, ' registros convertidos');
  Readkey;
end;
 
//-------------------------------------------------------------------
 
begin
  DefineBD(cAnoIni);
end.  