unit LibMenus3;

{ Desenvolvida pelo Prof. Gil Carlos Medeiros, no contexto didtico da
  disciplina de Programao de Microcomputadores, para uso pelos alunos
  como exemplo de manipulao dos diversos recursos, estruturas e tcnicas
  envolvidos na sua construo.
   livre a sua aplicao em programas relacionados a atividades prticas
  de apredizagem, bem como a sua modificao nesse mesmo interesse.
  Faam bom proveito!
}

interface

const MaxItens = 20;       { nmero mximo de itens em um menu }
      SepBlocoVert = '-';  { indicador de item separador de bloco vertical }

type ArrayMenu = array [1..MaxItens] of string;
     DirecaoMenu = (Nulo, Hori, Vert);      

var  mCorTextoMenu,        { cores usadas na apresentao dos menus } 
     mCorFundoMenu,
     mLarguraJanela,       { dimenses da janela onde o menu  apresentado }
     mAlturaJanela  : integer;
     
{ Funes que fazem apresentao e controle de navegao para um menu  }
{ horizontal ou vertical. A funo Menu integra as outras duas formas  }
{ individualizadas (MenuH/MenuV). Um menu vertical pode ser combinado  }
{ com um horizontal chamado anteriormente. Para isto, basta que o menu }
{ vertical seja chamado com valor "0" no parmetro 'coluna inicial'.   }
{ A navegao  feita pelo teclado (setas ou letra inicial da opo).  }
{ O valor retornado pelas funes  "-1", se o menu for abandonado sem }
{ seleo (tecla ESC ou, em menu vertical, seta para esquerda/direita),}
{ ou a "ordem da opo selecionada" (1 a n, de acordo com o nmero de  }
{ itens), se pressionada uma das teclas de seleo (tecla ENTER ou, em }
{ menu horizontal, seta para cima/baixo). Navegao implcita pode ser }
{ aplicada a um menu horizontal, logo aps um menu vertical combinado  }
{ ser abandonado por uma seta transversal (esquerda/direita).  Isto   }
{ feito indicando o valor "0" no parmetro 'opo inicial' ao chamar o }
{ menu horizontal.  Para menu com visibilidade parcial (em virtude dos }
{ limites da janela), as opes invisveis so selecionadas apenas por }
{ letra inicial (sem esperar confirmao por ENTER); nesse caso, no  }
{ tratada a repetio de letras iniciais.  A apresentao visual de um }
{ menu vertical pode formar blocos de itens usando separadores visuais }
{ (via itens com valor '-').                                           }

function Menu(Direc : DirecaoMenu; VetMenu : ArrayMenu;
              NumItens, ColIni, LinIni, OpIni : integer) : integer;

function MenuH(VetMenu : ArrayMenu; NumItens : integer; 
               ColIni, LinIni, OpIni : integer) : integer;

function MenuV(VetMenu : ArrayMenu; NumItens : integer; 
               ColIni, LinIni, OpIni : integer) : integer;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

implementation

const IndicadorDeItensInvisiveis = '...';

var ColIniH : array [1..MaxItens] of byte;
var UltimoItemHori : integer; { ltima opo horiz. confirmada (visvel); }
                              { se definida, sua ColIniH ser adotada em  }
                              { menu vert. chamado com 'ColIni' = 0       }
var UltCodTeclaSel : integer; { Cdigo da tecla de seleo aplicada }
                              { no ltimo menu usado                }

var TeclasAtalho : string;      { vlido como global porque s h um menu ativo }
    NumTeclasAtalho : integer;  { " }

{ L um caractere do teclado (para 'Tecla')  e o seu cdigo (em 'Cod').  }
{ Se a tecla digitada produz cdigo de verificao prvio (#0), ignora-o }
{ mas acrescenta o valor 1000 ao cdigo do caractere lido, para indicar  }
{ a ocorrncia de cdigo extendido (teclas de funo/controle).          }
procedure ReadKeyCode(var Tecla : char; var Cod : integer);
begin
  Tecla := ReadKey;
  Cod   := Ord(Tecla);
  if Tecla = #0 then
    begin
    Tecla := ReadKey;
    Cod   := Ord(Tecla) + 1000;
    end;
end;
    
{ Monta uma lista de Atalhos definidos para o Menu }
procedure MontaListaDeAtalhos(ItensMenu : ArrayMenu; NumItens : integer; 
                              Direc : DirecaoMenu);
var i : integer;
begin
  TeclasAtalho := '';         { atualmente, os atalhos so as letras iniciais }
  for i:=1 to NumItens do     { incluindo eventuais itens invisveis }
    if (Direc = Vert) and (ItensMenu[i] = SepBlocoVert) then
      TeclasAtalho := TeclasAtalho + #27  { s para ocupar a posio e alinhar }
    else                             { pega o primeiro caractere da opo i }
      TeclasAtalho := TeclasAtalho + UpCase(ItensMenu[i][1]);
  NumTeclasAtalho := NumItens;
end;

{ Seleciona item e guarda informaes pertinentes }
function SelecItem(i : integer; kcod : integer; Direc : DirecaoMenu) : integer;
begin     
  SelecItem := i;             { opo escolhida }
  UltCodTeclaSel := kcod;
  if Direc = Hori then
    UltimoItemHori := i
  else
    UltimoItemHori := 0;
end;

{ Seleciona prxima posio aps avaliao circular de possvel atalho; }
{ atualiza indicador de posio e fora a seleo, se maior que Limite; }
{ se Limite = 0, a seleo por atalho  automtica (sem precisar Enter) }
function SelecPorAtalho(CodTecla : integer; var PosAtu : integer;
                        Limite : integer) : integer;
var j : integer;
    k : char;
begin
  SelecPorAtalho := 0;
  if CodTecla < 1000 then
    begin
    k := UpCase( Chr(CodTecla) );   { para no diferenciar maisculas de minsculas }
    j := Pos(k, Copy(TeclasAtalho, PosAtu + 1, NumTeclasAtalho - PosAtu));
    if j > 0 then         { localizado atalho "posterior a" posio atual   }
      PosAtu := PosAtu + j 
    else
      begin
      j := Pos(k, TeclasAtalho); 
      if j > 0 then       { localizado atalho "anterior a/na" posio atual }
        PosAtu := j;      { seno, mantm a posio atual                   }
      end;
    if (j > 0) and (PosAtu > Limite) then  { Enter forado se pos. > limite }
      SelecPorAtalho := SelecItem(PosAtu, CodTecla, Nulo);
    end;
end;
    
{ Mostra cada opo de um Menu (uso interno); se Larg <= 0, a largura  o
  tamanho do string, espaos pr e ps so includos e '-' no  expandido }
procedure MostraItemMenu(OpStr : string; Col, Lin, Larg, Tcor, Fcor : integer);
var j : integer;
begin
  Textcolor(Tcor);
  Textbackground(Fcor);
  Gotoxy(Col, Lin);
  if Larg = 0 then
    Write(' ', OpStr, ' ')
  else
    if (OpStr = SepBlocoVert) then
      for j:=1 to Larg do Write(Chr(196))
    else
      Write(OpStr, '':(Larg - Length(Opstr)));
end;

{ Desenha uma borda em torno da rea ocupada pelo menu vertical } 
procedure DefineBorda(ColIni, LinIni, LarguraMenu, AlturaMenu : integer;
                      MenuParcial : boolean);
var i : integer;
begin
  Textbackground(cyan);
  for i:=LinIni-1 to LinIni+AlturaMenu do
    begin
    GotoXY(ColIni-1, i);  Write('':(LarguraMenu+2));
    end;
  if MenuParcial then
    begin
    GotoXY(ColIni, i);
    if LarguraMenu + 2 > Length(IndicadorDeItensInvisiveis) then
      Write(IndicadorDeItensInvisiveis)
    else
      Write(Copy(IndicadorDeItensInvisiveis, 1, 2));
    end;
end;

{ Ajusta Coluna Inicial para menus verticais }
procedure AjustaColIni(var ColIni : integer; Larg : integer);
begin
  if ColIni = 0 then
    if (UltimoItemHori > 0) and (ColIniH[UltimoItemHori] + Larg < mLarguraJanela) then
      ColIni := ColIniH[UltimoItemHori] + 1
    else
      ColIni := mLarguraJanela - Larg
  else
    if ColIni + Larg > mLarguraJanela then
      ColIni := mLarguraJanela - Larg;
end;

{ [Uso interno para garantir que caiba nos limites da rea de trabalho]
  Verifica o nmero de itens em relao aos demais parmetros e
  indica o nmero de itens que podem ser visveis, considerando
  reserva de espao para indicador de existncia de itens invisveis;
  se necessrio, o nm. de itens  ajustado  capacidade mxima;
  as colunas iniciais de cada item (horiz.) so determinadas e mantidas }
function ValidaArgs(var NumItens : integer; var Itens : ArrayMenu;
                    ColIni, LinIni : integer; Direc : DirecaoMenu) : integer;
var i, NumItensVal, Col : integer;
begin
  if NumItens > MaxItens then     { Ajusta ao tamanho do array }
    NumItens := MaxItens;

  case Direc of                   { Ajusta ao espao de tela }
    Hori: begin
          { Determina colunas iniciais, simultaneamente }
          i := 0;
          Col := ColIni;
          while (i < NumItens) and (Col - 1 <= mLarguraJanela) do
            begin
            i := i + 1;
            ColIniH[i] := Col;
            Col := Col + Length(Itens[i]) + 2;
            end;
          if Col - 1 > mLarguraJanela then
            begin
            Col := Col + Length(IndicadorDeItensInvisiveis) + 1;
            while Col > mLarguraJanela do
              begin
              Col := Col - Length(Itens[i]) - 2;
              i := i - 1;
              end;
            end;
          NumItensVal := i;
          end;
    Vert: if LinIni + NumItens <= mAlturaJanela then
            NumItensVal := NumItens
          else
            NumItensVal := mAlturaJanela - LinIni - 1; { prevendo sobra de uma linha }
    else  NumItensVal := 0;
    end;
  ValidaArgs := NumItensVal;
end;

{ Funo Menu Horizontal (ver descrio na seo de Interface) }
function MenuH(VetMenu : ArrayMenu; NumItens : integer;
               ColIni, LinIni, OpIni : integer) : integer;
var i, j, Lin, Col : integer;
    k : char; kcod : integer;
    Result : integer;
    NumItensVis : integer;

begin
  { Ajusta ao tamanho do array }
  if NumItens > MaxItens then
    NumItens := MaxItens;

  { Ajusta ao espao de tela e determina colunas iniciais }
  i := 0;
  Col := ColIni;
  while (i < NumItens) and (Col - 1 <= mLarguraJanela) do
    begin
    i := i + 1;
    ColIniH[i] := Col;
    Col := Col + Length(VetMenu[i]) + 2;
    end;
  if Col - 1 > mLarguraJanela then
    begin
    Col := Col + Length(IndicadorDeItensInvisiveis) + 1;
    while Col > mLarguraJanela do
      begin
      Col := Col - Length(VetMenu[i]) - 2;
      i := i - 1;
      end;
    end;
  NumItensVis := i;

  { Pega letras iniciais para usar como teclas de atalhos }
  MontaListaDeAtalhos(VetMenu, NumItens, Hori);
  
  { Mostra itens do menu }
  Lin := LinIni;
  for i:=1 to NumItensVis do
    MostraItemMenu(VetMenu[i], ColIniH[i], Lin, 0, mCorTextoMenu, mCorFundoMenu);
  if (NumItensVis <> NumItens) then
    MostraItemMenu(IndicadorDeItensInvisiveis, ColIniH[i+1], Lin, 0, 
                   mCorTextoMenu, mCorFundoMenu);

  Result := 0;
  cursoroff;
  { ajusta opo inicial }
  if (OpIni = 0) and (UltimoItemHori > 0) then
    case UltCodTeclaSel of
      1075: if UltimoItemHori = 1 then i := NumItensVis  else i := UltimoItemHori - 1;
      1077: if UltimoItemHori = NumItensVis then i := 1  else i := UltimoItemHori + 1;
      else  i := UltimoItemHori;
      end
  else if (OpIni < 1) or (OpIni > NumItensVis) then
    i := 1
  else
    i := OpIni;
  UltimoItemHori := 0;   { indefinido para invisveis ou no selec.}
  repeat
    MostraItemMenu(VetMenu[i], ColIniH[i], Lin, 0, mCorFundoMenu, mCorTextoMenu);
    ReadKeyCode(k, kcod);
    { teclas Enter, seta cima ou seta para baixo - seleo }
    if (kcod = 13) or (kcod = 1072) or (kcod = 1080) then
      Result := SelecItem(i, kcod, Hori)         { opo escolhida }
    else
      begin
      MostraItemMenu(VetMenu[i], ColIniH[i], Lin, 0, mCorTextoMenu, mCorFundoMenu);
      case kcod of
        27:   Result := -1;     { tecla Esc - abandono }
        1077:                   { tecla seta para direita - navegao avante }
              if i = NumItensVis then i := 1  else inc(i);
        1075:                   { tecla seta para esquerda - navegao a r }
              if i = 1 then i := NumItensVis  else dec(i);
        else  { verifica teclas de atalho, forando Enter p/ item invisvel }
              Result := SelecPorAtalho(kcod, i, NumItensVis);
        end;
      end;
  until Result <> 0;     { teclas Enter ou Esc ou naveg. transversal }
  cursoron;

  MenuH := Result;
end;

{ Funo Menu Vertical (ver descrio na seo de Interface) }
function MenuV(VetMenu : ArrayMenu; NumItens : integer;
               ColIni, LinIni, OpIni : integer) : integer;
var i, j, Lin, Col : integer;
    k : char; kcod : integer;
    Result : integer;
    Larg : integer;
    NumItensVis : integer;
begin
  { Ajusta ao tamanho do array }
  if NumItens > MaxItens then
    NumItens := MaxItens;

  { Determina largura necessria }
  Larg := 0;
  for i:=1 to NumItens do     { incluindo eventuais itens invisveis }
    begin
    j := Length(VetMenu[i]);
    if j > Larg then
      Larg := j;
    end;

  AjustaColIni(ColIni, Larg);

  { Ajusta ao espao de tela }
  NumItensVis := NumItens;
  if LinIni + NumItensVis > mAlturaJanela then
    NumItensVis := mAlturaJanela - LinIni - 1; { prevendo sobra de uma linha }
  
  { Pega letras iniciais para usar como teclas de atalhos }
  MontaListaDeAtalhos(VetMenu, NumItens, Vert);

  { Mostra itens do menu }
  Col := ColIni;
  Lin := LinIni;
  DefineBorda(ColIni, LinIni, Larg, NumItensVis, (NumItensVis < NumItens));
  for i:=1 to NumItensVis do
    begin
    MostraItemMenu(VetMenu[i], Col, Lin, Larg, mCorTextoMenu, mCorFundoMenu);
    Lin := Lin + 1;
    end;

  Result := 0;
  cursoroff;
  if (OpIni < 1) or (OpIni > NumItensVis) then
    i := 1
  else
    i := OpIni;
  repeat
    Lin := LinIni + i - 1;
    MostraItemMenu(VetMenu[i], Col, Lin, Larg, mCorFundoMenu, mCorTextoMenu);
    ReadKeyCode(k, kcod);
    { tecla Enter - seleo }
    if (kcod = 13) then
      Result := SelecItem(i, kcod, Vert)         { opo escolhida }
    else
      begin
      MostraItemMenu(VetMenu[i], Col, Lin, Larg, mCorTextoMenu, mCorFundoMenu);
      j := i;             { para verificar volta inteira sem opo selecionvel }
      case kcod of
        27:   Result := -1;    { tecla Esc   - abandono }
        1080: repeat           { tecla seta para baixo - navegao avante }
                if i = NumItensVis then i := 1  else inc(i);
              until (TeclasAtalho[i] <> #27) or (i = j);
        1072: repeat           { tecla seta para cima - navegao a r }
                if i = 1 then i := NumItensVis  else dec(i);
              until (TeclasAtalho[i] <> #27) or (i = j);
        1075,                  { tecla seta para esquerda - abandono a r }
        1077: begin            { tecla seta para direita - abandono avante }
              Result := -1;    UltCodTeclaSel := kcod;
              end;
        else  { verifica teclas de atalho, forando Enter p/ item invisvel }
              Result := SelecPorAtalho(kcod, i, NumItensVis);
        end;
      end;
  until Result <> 0;     { teclas Enter ou Esc ou naveg. transversal }
  cursoron;

  MenuV := Result;
end;
  
{ Funo Menu Horizontal/Vertical (ver descrio na seo de Interface) }
function Menu(Direc : DirecaoMenu; VetMenu : ArrayMenu;
              NumItens, ColIni, LinIni, OpIni : integer) : integer;
var i, j, Lin, Col : integer;
    k : char; kcod : integer;
    TeclaDeControle : boolean;
    Result : integer;
    Larg : integer;
    NumItensVis : integer;

begin
  NumItensVis := ValidaArgs(NumItens, VetMenu, ColIni, LinIni, Direc);
  
  { Determina/ajusta aspectos visuais para menu vertical }
  { (largura necessria, coluna inicial e borda)         }
  Larg := 0;               { para menu horizontal Larg permanecer em zero }
  if Direc = Vert then
    begin
    for i:=1 to NumItens do     { incluindo eventuais itens invisveis }
      begin
      j := Length(VetMenu[i]);
      if j > Larg then
        Larg := j;
      end;

    AjustaColIni(ColIni, Larg);
    DefineBorda(ColIni, LinIni, Larg, NumItensVis, (NumItensVis < NumItens));
    end;
 
  { Pega letras iniciais para usar como teclas de atalhos }
  MontaListaDeAtalhos(VetMenu, NumItens, Direc);

  { Mostra itens do menu }
  Col := ColIni;
  Lin := LinIni;
  for i:=1 to NumItensVis do
    begin
    case Direc of
      Hori: Col := ColIniH[i];
      Vert: Lin := LinIni + i - 1;
      end;
    MostraItemMenu(VetMenu[i], Col, Lin, Larg, mCorTextoMenu, mCorFundoMenu);
    end;
  if (Direc = Hori) and (NumItensVis <> NumItens) then
    MostraItemMenu(IndicadorDeItensInvisiveis, ColIniH[NumItensVis + 1], Lin,
                   0, mCorTextoMenu, mCorFundoMenu);

  Result := 0;
  cursoroff;
  if (Direc = Hori) and (OpIni = 0) and (UltimoItemHori > 0) then
    case UltCodTeclaSel of
      1075: if UltimoItemHori = 1 then i := NumItensVis  else i := UltimoItemHori - 1;
      1077: if UltimoItemHori = NumItensVis then i := 1  else i := UltimoItemHori + 1;
      else  i := UltimoItemHori;
      end
  else if (OpIni < 1) or (OpIni > NumItensVis) then
    i := 1
  else
    i := OpIni;
  if Direc = Hori then
    UltimoItemHori := 0;      { (pr-)indefinido para invisveis ou no selec.}
  repeat
    case Direc of
      Hori: Col := ColIniH[i];
      Vert: Lin := LinIni + i - 1;
      end;
    MostraItemMenu(VetMenu[i], Col, Lin, Larg, mCorFundoMenu, mCorTextoMenu);
    ReadKeyCode(k, kcod);
    { teclas Enter, seta transversal (cima/esquerda ou baixo/direita) - seleo }
    if (kcod = 13) or (Direc = Hori) and ((kcod = 1072) or (kcod = 1080)) then
      Result := SelecItem(i, kcod, Direc)         { opo escolhida }
    else
      begin
      MostraItemMenu(VetMenu[i], Col, Lin, Larg, mCorTextoMenu, mCorFundoMenu);
      j := i;             { para verificar volta inteira sem opo selecionvel }
      case kcod of
        27:  Result := -1;    { tecla Esc   - abandono }
        1075: if Direc = Vert then     { tecla seta para esquerda }
                begin                    { - abandono a r }
                Result := -1;    UltCodTeclaSel := kcod;
                end
              else                       { - navegao a r }
                if i = 1 then i := NumItensVis  else dec(i);
        1077: if Direc = Vert then     { tecla seta para direita }
                begin                    { - abandono avante }
                Result := -1;    UltCodTeclaSel := kcod;
                end
              else                       { - navegao avante }
                if i = NumItensVis then i := 1  else inc(i);
        1072: repeat           { tecla seta para cima - navegao a r }
                if i = 1 then i := NumItensVis  else dec(i);
              until (TeclasAtalho[i] <> #27) or (i = j);
        1080: repeat           { tecla seta para baixo - navegao avante }
                if i = NumItensVis then i := 1  else inc(i);
              until (TeclasAtalho[i] <> #27) or (i = j);
        else  { verifica teclas de atalho, forando Enter p/ item invisvel }
              Result := SelecPorAtalho(kcod, i, NumItensVis);
        end;
      end;
  until Result <> 0;     { teclas Enter ou Esc ou naveg. transversal }
  cursoron;

  Menu := Result;
end;

// - - - - - - - - - - - - - Inicializao da Unit - - - - - - - - - - - - -
begin
  mCorTextoMenu  := White;
  mCorFundoMenu  := Black;
  mLarguraJanela := 80;
  mAlturaJanela  := 20;     { window com linhas de 4 a 23, por exemplo }
  
  UltimoItemHori := 0;
  UltCodTeclaSel := 0;
end.
